/*
 *
 * Quelle: swfltek.com
 *
 * myTimeLord.h
 *
 *  Created on: 03.10.2012
 *      Author: Elmar Faber
 */

#ifndef MYTIMELORD_H_
#define MYTIMELORD_H_

#include <inttypes.h>
#include <stdbool.h>
#include <Math.h>

#define tl_second 0
#define tl_minute 1
#define tl_hour   2
#define tl_day    3
#define tl_month  4
#define tl_year   5

// configuration
struct myTimeLord_struct
{
  float latitude;
  float longitude;
  int   timezone;
  uint8_t dstm1, dstw1, dstm2, dstw2, dstadv;
};

void TimeLord_Init(struct myTimeLord_struct* tl);

bool TimeLord_Position(struct myTimeLord_struct* tl, float lat, float lon);
bool TimeLord_TimeZone(struct myTimeLord_struct* tl, int tz);
bool TimeLord_DstRules(struct myTimeLord_struct* tl, uint8_t,uint8_t,uint8_t,uint8_t,uint8_t);

// Political

void TimeLord_GMT(struct myTimeLord_struct* tl,uint8_t *);
void TimeLord_DST(struct myTimeLord_struct* tl,uint8_t *);

//Solar & Astronomical

bool  TimeLord_SunRise(struct myTimeLord_struct* tl,uint8_t *);
bool  TimeLord_SunSet (struct myTimeLord_struct* tl,uint8_t *);
float TimeLord_MoonPhase(uint8_t *);
void  TimeLord_Sidereal(struct myTimeLord_struct* tl,uint8_t *, bool);
uint8_t TimeLord_Season(struct myTimeLord_struct* tl,uint8_t *);

// Utility

uint8_t TimeLord_DayOfWeek(uint8_t *);
uint8_t TimeLord_LengthOfMonth(uint8_t *);
bool    TimeLord_IsLeapYear(int);

void Adjust(uint8_t *, long);
char Signum(int);
int  Absolute(int);

bool TimeLord_ComputeSun(struct myTimeLord_struct* tl,uint8_t *, bool);
long TimeLord_DayNumber(uint16_t, uint8_t, uint8_t);
bool TimeLord_InDst(struct myTimeLord_struct* tl,uint8_t *);

uint8_t TimeLord__season(uint8_t *);

#endif /* MYTIMELORD_H_ */
